﻿using NAudio.Wave;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;



namespace SpaceAlert_MissionCreator
{
    public partial class MainFrame : Form
    {
        //Member Variables
        public string audioFilesPath = Application.StartupPath + "/audio/";

        public string audioFileUnbestätigerBericht = "unbestätigterBericht.mp3";

        public string audioFileDatenübertragung = "datenübertragung.mp3";
        public string audioFileDatenübertragungAbgeschlossen = "datenübertragungAbgeschlossen.mp3";
        public string audioFileEingehendeDaten = "eingehendeDaten.mp3";
        public string audioFileKommunikationGestörtKurz = "kommunikationGestörtKurz.mp3";
        public string audioFileKommunikationGestörtLang = "kommunikationGestörtLang.mp3";
        public string audioFileBedrohung = "bedrohung.mp3";
        public string audioFileErnsthafteBedrohung = "ernsthafteBedrohung.mp3";
        public string audioFileInterneBedrohung = "interneBedrohung.mp3";
        public string audioFileErnsthafteInterneBedrohung = "ernsthafteInterneBedrohung.mp3";

        public string audioFileZoneRot = "zoneRot.mp3";
        public string audioFileZoneWeiß = "zoneWeiß.mp3";
        public string audioFileZoneBlau = "zoneBlau.mp3";

        public string[] audioFilesZiffern = new string[] { "ziffer_1.mp3", "ziffer_2.mp3", "ziffer_3.mp3", "ziffer_4.mp3", "ziffer_5.mp3", "ziffer_6.mp3", "ziffer_7.mp3", "ziffer_8.mp3", "ziffer_9.mp3" };

        public string audioFileIn = "in.mp3";
        public string audioFileZeitTPlus = "zeitTPlus.mp3";
        public string audioFileInZone = "inZone.mp3";
        public string audioFileWiederhole = "wiederhole.mp3";
        public string audioFileMissionGestartet = "missionGestartet.mp3";
        public string audioFilePhase1Beginnen = "phase1Beginnen.mp3";
        public string audioFilePhase1EndetIn60Sekunden = "phase1EndetIn60Sekunden.mp3";
        public string audioFilePhase1EndetIn20Sekunden = "phase1EndetIn20Sekunden.mp3";
        public string audioFilePhase1Beendet = "phase1Beendet.mp3";
        public string audioFilePhase2Beginnen = "phase2Beginnen.mp3";
        public string audioFilePhase2EndetIn60Sekunden = "phase2EndetIn60Sekunden.mp3";
        public string audioFilePhase2EndetIn20Sekunden = "phase2EndetIn20Sekunden.mp3";
        public string audioFilePhase2Beendet = "phase2Beendet.mp3";
        public string audioFilePhase3Beginnen = "phase3Beginnen.mp3";
        public string audioFileMissionEndetIn60Sekunden = "missionEndetIn60Sekunden.mp3";
        public string audioFileMissionEndetIn20Sekunden = "missionEndetIn20Sekunden.mp3";
        public string audioFileMissionBeendet = "missionBeendet.mp3";



        /// <summary>
        /// Constructor.
        /// </summary>
        public MainFrame()
        {
            InitializeComponent();

            init();
        }



        /// <summary>
        /// Inits the Application.
        /// </summary>
        public void init()
        {
            //Init Components
            comboBox_eventType.SelectedIndex = 0;
            comboBox_zone.SelectedIndex = 0;
            comboBox_minute.SelectedIndex = 0;
            trackBar_timer.Value = 0;
            trackBar_timer_Scroll(null, null);

            //Add essential Events
            dataGridView_missionData.Rows.Clear();
            dataGridView_missionData.Rows.Add(10);

            //Mission start
            dataGridView_missionData[0, 0].Value = "";
            dataGridView_missionData[1, 0].Value = "Mission gestartet";
            dataGridView_missionData[2, 0].Value = "";
            dataGridView_missionData[3, 0].Value = "";
            dataGridView_missionData[4, 0].Value = "00:00";

            //Phase 1
            dataGridView_missionData[0, 1].Value = "";
            dataGridView_missionData[1, 1].Value = "Phase 1 endet in 60 Sekunden";
            dataGridView_missionData[2, 1].Value = "";
            dataGridView_missionData[3, 1].Value = "";
            dataGridView_missionData[4, 1].Value = "03:00";

            dataGridView_missionData[0, 2].Value = "";
            dataGridView_missionData[1, 2].Value = "Phase 1 endet in 20 Sekunden";
            dataGridView_missionData[2, 2].Value = "";
            dataGridView_missionData[3, 2].Value = "";
            dataGridView_missionData[4, 2].Value = "03:40";

            dataGridView_missionData[0, 3].Value = "";
            dataGridView_missionData[1, 3].Value = "Phase 1 beendet";
            dataGridView_missionData[2, 3].Value = "";
            dataGridView_missionData[3, 3].Value = "";
            dataGridView_missionData[4, 3].Value = "04:00";

            //Phase 2
            dataGridView_missionData[0, 4].Value = "";
            dataGridView_missionData[1, 4].Value = "Phase 2 endet in 60 Sekunden";
            dataGridView_missionData[2, 4].Value = "";
            dataGridView_missionData[3, 4].Value = "";
            dataGridView_missionData[4, 4].Value = "06:30";

            dataGridView_missionData[0, 5].Value = "";
            dataGridView_missionData[1, 5].Value = "Phase 2 endet in 20 Sekunden";
            dataGridView_missionData[2, 5].Value = "";
            dataGridView_missionData[3, 5].Value = "";
            dataGridView_missionData[4, 5].Value = "07:10";

            dataGridView_missionData[0, 6].Value = "";
            dataGridView_missionData[1, 6].Value = "Phase 2 beendet";
            dataGridView_missionData[2, 6].Value = "";
            dataGridView_missionData[3, 6].Value = "";
            dataGridView_missionData[4, 6].Value = "07:30";

            //Mission End
            dataGridView_missionData[0, 7].Value = "";
            dataGridView_missionData[1, 7].Value = "Mission endet in 60 Sekunden";
            dataGridView_missionData[2, 7].Value = "";
            dataGridView_missionData[3, 7].Value = "";
            dataGridView_missionData[4, 7].Value = "09:00";

            dataGridView_missionData[0, 8].Value = "";
            dataGridView_missionData[1, 8].Value = "Mission endet in 20 Sekunden";
            dataGridView_missionData[2, 8].Value = "";
            dataGridView_missionData[3, 8].Value = "";
            dataGridView_missionData[4, 8].Value = "09:40";

            dataGridView_missionData[0, 9].Value = "";
            dataGridView_missionData[1, 9].Value = "Mission beendet";
            dataGridView_missionData[2, 9].Value = "";
            dataGridView_missionData[3, 9].Value = "";
            dataGridView_missionData[4, 9].Value = "10:00";

            //Sort
            dataGridView_missionData.Sort(dataGridView_missionData.Columns[4], ListSortDirection.Ascending);

            //Draw Timeslider and Thread Count
            setTimeLine();
            setThreatCount();
        }



        /// <summary>
        /// Activate or deactivate some Components for specific Events.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboBox_eventType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox_eventType.Text.Equals("Bedrohung") || comboBox_eventType.Text.Equals("Ernsthafte Bedrohung"))
            {
                checkBox_unconfirmed.Enabled = true;
                comboBox_minute.Enabled = true;
                comboBox_zone.Enabled = true;
            }

            if (comboBox_eventType.Text.Equals("Interne Bedrohung") || comboBox_eventType.Text.Equals("Ernsthafte Interne Bedrohung"))
            {
                checkBox_unconfirmed.Enabled = true;
                comboBox_minute.Enabled = true;
                comboBox_zone.Enabled = false;
            }

            if (comboBox_eventType.Text.Equals("Datenübertragung") || comboBox_eventType.Text.Equals("Eingehende Daten") || comboBox_eventType.Text.Equals("Kommunikation gestört (kurz)") || comboBox_eventType.Text.Equals("Kommunikation gestört (lang)"))
            {
                checkBox_unconfirmed.Checked = false;
                checkBox_unconfirmed.Enabled = false;
                comboBox_minute.Enabled = false;
                comboBox_zone.Enabled = false;
            }
        }



        /// <summary>
        /// Slider to set the exact Time to start an Event.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void trackBar_timer_Scroll(object sender, EventArgs e)
        {
            textBox_timer.Text = TimeSpan.FromSeconds(trackBar_timer.Value * 5).ToString(@"mm\:ss");
        }



        /// <summary>
        /// Adds the user defined Event to the Event List.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_add_Click(object sender, EventArgs e)
        {
            //Add a new Row
            dataGridView_missionData.Rows.Add();

            //Add Data to Row

            //Unconfirmed
            if (checkBox_unconfirmed.Checked)
            {
                dataGridView_missionData[0, dataGridView_missionData.Rows.Count - 1].Value = "x";
            }
            else
            {
                dataGridView_missionData[0, dataGridView_missionData.Rows.Count - 1].Value = "";
            }

            //Event Type
            dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = comboBox_eventType.Text;

            //Zone
            if (comboBox_zone.Enabled)
            {
                dataGridView_missionData[2, dataGridView_missionData.Rows.Count - 1].Value = comboBox_zone.Text;
            }
            else
            {
                dataGridView_missionData[2, dataGridView_missionData.Rows.Count - 1].Value = "";
            }

            //TPlus
            if (comboBox_minute.Enabled)
            {
                dataGridView_missionData[3, dataGridView_missionData.Rows.Count - 1].Value = comboBox_minute.Text;
            }
            else
            {
                dataGridView_missionData[3, dataGridView_missionData.Rows.Count - 1].Value = "";
            }

            //Time
            dataGridView_missionData[4, dataGridView_missionData.Rows.Count - 1].Value = textBox_timer.Text;

            //Sort
            dataGridView_missionData.Sort(dataGridView_missionData.Columns[4], ListSortDirection.Ascending);

            //Draw Timeslider and Thread Count
            setTimeLine();
            setThreatCount();
        }



        /// <summary>
        /// Removes the currently selected Rows - only user inserted Events.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_remove_Click(object sender, EventArgs e)
        {
            //Loop over selected Rows
            for (int y = dataGridView_missionData.SelectedRows.Count - 1; y >= 0; y--)
            {
                //Check, if the selected Row contains a non-essential Event. If so, delete Row.
                if (comboBox_eventType.Items.Contains(dataGridView_missionData.SelectedRows[y].Cells[1].Value))
                {
                    dataGridView_missionData.Rows.Remove(dataGridView_missionData.SelectedRows[y]);
                }
            }

            //Sort
            dataGridView_missionData.Sort(dataGridView_missionData.Columns[4], ListSortDirection.Ascending);

            //Draw Timeslider and Thread Count
            setTimeLine();
            setThreatCount();
        }



        /// <summary>
        /// Calls the Random Mission Generator Dialog.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_rangomGenerator_Click(object sender, EventArgs e)
        {
            
            RandomMissionDialog randomMissionDialog = new RandomMissionDialog(this);
            randomMissionDialog.ShowDialog();

            

            //Add Threats
            for (int i = 0; i < randomMissionDialog.threats.Count; i++)
            {
                //Add a new Row
                dataGridView_missionData.Rows.Add();

                //Fill Row with empty Strings
                for(int j = 0; j < dataGridView_missionData.Columns.Count; j++)
                {
                    dataGridView_missionData[j, dataGridView_missionData.Rows.Count - 1].Value = "";
                }

                //Add Data to Row

                //Event Type
                if (randomMissionDialog.threats[i].externalThreat)
                {
                    if (randomMissionDialog.threats[i].seriousThreat)
                    {
                        dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Ernsthafte Bedrohung";
                    }

                    if (!randomMissionDialog.threats[i].seriousThreat)
                    {
                        dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Bedrohung";
                    }
                }

                if (!randomMissionDialog.threats[i].externalThreat)
                {
                    if (randomMissionDialog.threats[i].seriousThreat)
                    {
                        dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Ernsthafte Interne Bedrohung";
                    }

                    if (!randomMissionDialog.threats[i].seriousThreat)
                    {
                        dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Interne Bedrohung";
                    }
                }

                //Zone
                dataGridView_missionData[2, dataGridView_missionData.Rows.Count - 1].Value = randomMissionDialog.threats[i].zone;

                //TPlus
                dataGridView_missionData[3, dataGridView_missionData.Rows.Count - 1].Value = randomMissionDialog.threats[i].timeTPlus;

                //Time
                dataGridView_missionData[4, dataGridView_missionData.Rows.Count - 1].Value = TimeSpan.FromSeconds(randomMissionDialog.threats[i].secondsToDeploy).ToString(@"mm\:ss");
            }

            //Add DataTransfers
            for(int i = 0; i < randomMissionDialog.secondsToDeployDataTransfer.Count; i++)
            {
                //Add a new Row
                dataGridView_missionData.Rows.Add();

                //Fill Row with empty Strings
                for (int j = 0; j < dataGridView_missionData.Columns.Count; j++)
                {
                    dataGridView_missionData[j, dataGridView_missionData.Rows.Count - 1].Value = "";
                }

                //Event Type
                dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Datenübertragung";

                //Time
                dataGridView_missionData[4, dataGridView_missionData.Rows.Count - 1].Value = TimeSpan.FromSeconds(randomMissionDialog.secondsToDeployDataTransfer[i]).ToString(@"mm\:ss");
            }

            for (int i = 0; i < randomMissionDialog.secondsToDeployIncommingData.Count; i++)
            {
                //Add a new Row
                dataGridView_missionData.Rows.Add();

                //Fill Row with empty Strings
                for (int j = 0; j < dataGridView_missionData.Columns.Count; j++)
                {
                    dataGridView_missionData[j, dataGridView_missionData.Rows.Count - 1].Value = "";
                }

                //Event Type
                dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Eingehende Daten";

                //Time
                dataGridView_missionData[4, dataGridView_missionData.Rows.Count - 1].Value = TimeSpan.FromSeconds(randomMissionDialog.secondsToDeployIncommingData[i]).ToString(@"mm\:ss");
            }

            //Add CommunicationBlackouts
            for (int i = 0; i < randomMissionDialog.secondsToDeployCommunicationBlackoutShort.Count; i++)
            {
                //Add a new Row
                dataGridView_missionData.Rows.Add();

                //Fill Row with empty Strings
                for (int j = 0; j < dataGridView_missionData.Columns.Count; j++)
                {
                    dataGridView_missionData[j, dataGridView_missionData.Rows.Count - 1].Value = "";
                }

                //Event Type
                dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Kommunikation gestört (kurz)";

                //Time
                dataGridView_missionData[4, dataGridView_missionData.Rows.Count - 1].Value = TimeSpan.FromSeconds(randomMissionDialog.secondsToDeployCommunicationBlackoutShort[i]).ToString(@"mm\:ss");
            }

            for (int i = 0; i < randomMissionDialog.secondsToDeployCommunicationBlackoutLong.Count; i++)
            {
                //Add a new Row
                dataGridView_missionData.Rows.Add();

                //Fill Row with empty Strings
                for (int j = 0; j < dataGridView_missionData.Columns.Count; j++)
                {
                    dataGridView_missionData[j, dataGridView_missionData.Rows.Count - 1].Value = "";
                }

                //Event Type
                dataGridView_missionData[1, dataGridView_missionData.Rows.Count - 1].Value = "Kommunikation gestört (lang)";

                //Time
                dataGridView_missionData[4, dataGridView_missionData.Rows.Count - 1].Value = TimeSpan.FromSeconds(randomMissionDialog.secondsToDeployCommunicationBlackoutLong[i]).ToString(@"mm\:ss");
            }

            //Sort
            dataGridView_missionData.Sort(dataGridView_missionData.Columns[4], ListSortDirection.Ascending);

            //Draw Timeslider and Thread Count
            setTimeLine();
            setThreatCount();
        }



        /// <summary>
        /// Resets the current Mission.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_new_Click(object sender, EventArgs e)
        {
            if(MessageBox.Show("Wollen Sie eine neue Mission erstellen?\n\nUngespeicherte Änderungen gehen hierdurch verloren.", "Info", MessageBoxButtons.OKCancel) == DialogResult.OK)
            {
                init();
            }
        }
        


        /// <summary>
        /// Saves the Mission as a XML File.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_save_Click(object sender, EventArgs e)
        {
            //Document and Root Node
            XmlDocument xmlDoc = new XmlDocument();
            XmlNode rootNode = xmlDoc.CreateElement("mission");
            xmlDoc.AppendChild(rootNode);

            //Loop over Events
            for(int i = 0; i < dataGridView_missionData.Rows.Count; i++)
            {
                //Event Node
                XmlNode eventNode = xmlDoc.CreateElement("event");
                rootNode.AppendChild(eventNode);

                //Loop over event Data
                for(int j = 0; j < dataGridView_missionData.Columns.Count; j++)
                {
                    //Event Data Nodes
                    XmlNode dataNode = xmlDoc.CreateElement(dataGridView_missionData.Columns[j].HeaderText);
                    dataNode.InnerText = dataGridView_missionData[j, i].Value.ToString();
                    eventNode.AppendChild(dataNode);
                }
            }

            //Save Document (show saveFileDialog)
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "xml|*.xml";
            saveFileDialog.InitialDirectory = Application.StartupPath;

            if(saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                xmlDoc.Save(saveFileDialog.FileName);
            }
            
        }



        /// <summary>
        /// Loads a Mission from an XML File.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_load_Click(object sender, EventArgs e)
        {
            //Open Document (show openFileDialog)
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "xml|*.xml";
            openFileDialog.InitialDirectory = Application.StartupPath;
            openFileDialog.Multiselect = false;

            if(openFileDialog.ShowDialog() == DialogResult.OK)
            {
                //Clear DataGridView
                dataGridView_missionData.Rows.Clear();

                //Document and Root Node
                XmlDocument xmlDoc = new XmlDocument();
                xmlDoc.Load(openFileDialog.FileName);
                XmlNode rootNode = xmlDoc.DocumentElement;

                //Loop over Events
                for(int i = 0; i < rootNode.ChildNodes.Count; i++)
                {
                    XmlNode eventNode = rootNode.ChildNodes[i];
                    dataGridView_missionData.Rows.Add();

                    //Loop over Event Data
                    for (int j = 0; j < eventNode.ChildNodes.Count; j++)
                    {
                        dataGridView_missionData[j, i].Value = eventNode.ChildNodes[j].InnerText;
                    }
                }
            }

            //Sort
            dataGridView_missionData.Sort(dataGridView_missionData.Columns[4], ListSortDirection.Ascending);

            //Draw Timeslider and Thread Count
            setTimeLine();
            setThreatCount();
        }



        /// <summary>
        /// Exports the Mission as a WAV File.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_export_Click(object sender, EventArgs e)
        {
            //Save exported File (show saveFileDialog)
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "wav|*.wav";
            saveFileDialog.InitialDirectory = Application.StartupPath;

            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                //First pass: create Event-Sounds

                //Create List Events. Each Event contains all Sound Files, which will be merged together
                List<List<string>> events = new List<List<string>>();
                List<int> secondsToDeploy = new List<int>();

                //Handle all Events
                for (int i = 0; i < dataGridView_missionData.Rows.Count; i++)
                {
                    events.Add(new List<string>());
                    secondsToDeploy.Add((int)TimeSpan.ParseExact(dataGridView_missionData[4, i].Value.ToString(), @"mm\:ss", CultureInfo.InvariantCulture).TotalSeconds);

                    if(dataGridView_missionData[0, i].Value.Equals("x"))
                    {
                        events[i].Add(audioFileUnbestätigerBericht);
                    }

                    #region setAudioFiles
                    switch (dataGridView_missionData[1, i].Value.ToString())
                    {
                        case "Datenübertragung":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileDatenübertragung);

                            break;

                        case "Eingehende Daten":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileEingehendeDaten);

                            break;

                        case "Kommunikation gestört (kurz)":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileKommunikationGestörtKurz);

                            break;

                        case "Kommunikation gestört (lang)":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileKommunikationGestörtLang);

                            break;

                        case "Bedrohung":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileBedrohung);

                            switch (dataGridView_missionData[2, i].Value.ToString())
                            {
                                case "Rot":
                                    events[i].Add(audioFileZoneRot);
                                    break;
                                case "Weiß":
                                    events[i].Add(audioFileZoneWeiß);
                                    break;
                                case "Blau":
                                    events[i].Add(audioFileZoneBlau);
                                    break;
                            }

                            events[i].Add(audioFileWiederhole);
                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileBedrohung);

                            switch (dataGridView_missionData[2, i].Value.ToString())
                            {
                                case "Rot":
                                    events[i].Add(audioFileZoneRot);
                                    break;
                                case "Weiß":
                                    events[i].Add(audioFileZoneWeiß);
                                    break;
                                case "Blau":
                                    events[i].Add(audioFileZoneBlau);
                                    break;
                            }

                            break;

                        case "Ernsthafte Bedrohung":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileErnsthafteBedrohung);

                            switch (dataGridView_missionData[2, i].Value.ToString())
                            {
                                case "Rot":
                                    events[i].Add(audioFileZoneRot);
                                    break;
                                case "Weiß":
                                    events[i].Add(audioFileZoneWeiß);
                                    break;
                                case "Blau":
                                    events[i].Add(audioFileZoneBlau);
                                    break;
                            }

                            events[i].Add(audioFileWiederhole);
                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileErnsthafteBedrohung);

                            switch (dataGridView_missionData[2, i].Value.ToString())
                            {
                                case "Rot":
                                    events[i].Add(audioFileZoneRot);
                                    break;
                                case "Weiß":
                                    events[i].Add(audioFileZoneWeiß);
                                    break;
                                case "Blau":
                                    events[i].Add(audioFileZoneBlau);
                                    break;
                            }

                            break;

                        case "Interne Bedrohung":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileInterneBedrohung);
                            events[i].Add(audioFileWiederhole);
                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileInterneBedrohung);

                            break;

                        case "Ernsthafte Interne Bedrohung":

                            if (dataGridView_missionData[1, i].Value.Equals("x"))
                            {
                                events[i].Add(audioFileUnbestätigerBericht);
                            }

                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileErnsthafteInterneBedrohung);
                            events[i].Add(audioFileWiederhole);
                            events[i].Add(audioFileZeitTPlus);
                            events[i].Add(audioFilesZiffern[int.Parse(dataGridView_missionData[3, i].Value.ToString()) - 1]);
                            events[i].Add(audioFileErnsthafteInterneBedrohung);

                            break;

                        case "Mission gestartet":

                            events[i].Add(audioFileMissionGestartet);
                            events[i].Add(audioFilePhase1Beginnen);

                            break;

                        case "Phase 1 endet in 60 Sekunden":

                            events[i].Add(audioFilePhase1EndetIn60Sekunden);

                            break;

                        case "Phase 1 endet in 20 Sekunden":

                            events[i].Add(audioFilePhase1EndetIn20Sekunden);

                            break;

                        case "Phase 1 beendet":

                            events[i].Add(audioFilePhase1Beendet);
                            events[i].Add(audioFilePhase2Beginnen);

                            break;

                        case "Phase 2 endet in 60 Sekunden":

                            events[i].Add(audioFilePhase2EndetIn60Sekunden);

                            break;

                        case "Phase 2 endet in 20 Sekunden":

                            events[i].Add(audioFilePhase2EndetIn20Sekunden);

                            break;

                        case "Phase 2 beendet":

                            events[i].Add(audioFilePhase2Beendet);
                            events[i].Add(audioFilePhase3Beginnen);

                            break;

                        case "Mission endet in 60 Sekunden":

                            events[i].Add(audioFileMissionEndetIn60Sekunden);

                            break;

                        case "Mission endet in 20 Sekunden":

                            events[i].Add(audioFileMissionEndetIn20Sekunden);

                            break;

                        case "Mission beendet":

                            events[i].Add(audioFileMissionBeendet);

                            break;

                    }
                    #endregion
                }

                #region debug
                /*if (true)
                {
                    FileStream fileStream = new FileStream("debug.txt", FileMode.Create);
                    StreamWriter streamWriter = new StreamWriter(fileStream);

                    for (int i = 0; i < events.Count; i++)
                    {
                        streamWriter.WriteLine("");
                        streamWriter.WriteLine(secondsToDeploy[i]);

                        for (int j = 0; j < events[i].Count; j++)
                        {
                            streamWriter.WriteLine(events[i][j]);
                        }
                    }

                    streamWriter.Flush();
                    streamWriter.Close();
                    fileStream.Close();
                }*/
                #endregion

                #region writeAudioFiles

                //Variables
                WaveMixerStream32 mixer;
                WaveFileWriter waveFileWriter;
                WaveFileReader waveFileReader;
                WaveStream waveStream;
                Mp3FileReader mp3Reader;
                byte[] buffer;
                byte[] emptyData;
                long currentPositionInMilliseconds = 0;

                //Init Mixer once to get a WaveFormat
                Mp3FileReader mp3Reader1 = new Mp3FileReader("audio/bedrohung.mp3");
                mixer = new WaveMixerStream32();
                mixer.AddInputStream(new WaveChannel32(mp3Reader1));
                mixer.Position = 0;

                waveFileWriter = new WaveFileWriter(saveFileDialog.FileName, mixer.WaveFormat);
                emptyData = new byte[waveFileWriter.WaveFormat.AverageBytesPerSecond / 10];

                mp3Reader1.Close();
                mixer.Close();

                /*MessageBox.Show((mixer.Length * 1000 / mixer.WaveFormat.AverageBytesPerSecond).ToString());
                MessageBox.Show(mixer.WaveFormat.AverageBytesPerSecond.ToString());
                MessageBox.Show(mixer.WaveFormat.BlockAlign.ToString());
                MessageBox.Show(mixer.WaveFormat.SampleRate.ToString());
                MessageBox.Show(mixer.WaveFormat.BitsPerSample.ToString());
                MessageBox.Show(mixer.WaveFormat.Channels.ToString());*/

                //Write Event Sounds
                while (events.Count > 0)
                {
                    //Add 100 Milliseconds of Silence
                    if (currentPositionInMilliseconds < secondsToDeploy[0] * 1000)
                    {
                        waveFileWriter.Write(emptyData, 0, emptyData.Length);

                        currentPositionInMilliseconds += 100;
                        toolStripProgressBar.Value = Math.Min((int)currentPositionInMilliseconds, toolStripProgressBar.Maximum);
                        toolStripProgressBar.Invalidate();
                        continue;
                    }

                    //Add Sound
                    if (currentPositionInMilliseconds >= secondsToDeploy[0] * 1000)
                    {
                        //Loop over all Event Sounds
                        for (int i = 0; i < events[0].Count; i++)
                        {
                            //Init Input Stream
                            mp3Reader = new Mp3FileReader(audioFilesPath + events[0][i]);
                            //mp3Reader = new Mp3FileReader("input.mp3");
                            mixer = new WaveMixerStream32();
                            mixer.AddInputStream(new WaveChannel32(mp3Reader));
                            mixer.Position = 0;
                            buffer = new byte[mixer.WaveFormat.BlockAlign];

                            //Write to Output
                            for (int j = 0; j < mixer.Length / mixer.WaveFormat.BlockAlign; j++)
                            {
                                mixer.Read(buffer, 0, mixer.WaveFormat.BlockAlign);

                                for (int k = 0; k < buffer.Length; k++)
                                {
                                    waveFileWriter.WriteByte(buffer[k]);
                                }
                            }

                            //Close Mixer
                            waveFileWriter.Flush();
                            mp3Reader.Close();
                            mixer.Close();

                            currentPositionInMilliseconds += mixer.Length * 1000 / mixer.WaveFormat.AverageBytesPerSecond;
                            toolStripProgressBar.Value = Math.Min((int)currentPositionInMilliseconds, toolStripProgressBar.Maximum);
                            toolStripProgressBar.Invalidate();
                        }

                        //Event handled
                        events.RemoveAt(0);
                        secondsToDeploy.RemoveAt(0);
                        continue;
                    }
                }

                toolStripProgressBar.Value = 0;

                //Close Output File
                waveFileWriter.Flush();
                waveFileWriter.Close();
                #endregion

                #region Second pass: add Music

                //Load Input and add to Mixer
                //waveStream = new WaveChannel32(new Mp3FileReader(textBox_music.Text));
                //waveFileReader = new WaveFileReader("tmp.wav");

                /*MessageBox.Show(waveStream.WaveFormat.AverageBytesPerSecond.ToString() + "   " + waveFileReader.WaveFormat.AverageBytesPerSecond.ToString());
                MessageBox.Show(waveStream.WaveFormat.BlockAlign.ToString() + "   " + waveFileReader.WaveFormat.BlockAlign.ToString());
                MessageBox.Show(waveStream.WaveFormat.SampleRate.ToString() + "   " + waveFileReader.WaveFormat.SampleRate.ToString());
                MessageBox.Show(waveStream.WaveFormat.BitsPerSample.ToString() + "   " + waveFileReader.WaveFormat.BitsPerSample.ToString());
                MessageBox.Show(waveStream.WaveFormat.Channels.ToString() + "   " + waveFileReader.WaveFormat.Channels.ToString());*/

                /*mixer = new WaveMixerStream32();
                mixer.AddInputStream(waveStream);
                mixer.AddInputStream(waveFileReader);
                mixer.Position = 0;
                //buffer = new byte[mixer.WaveFormat.BlockAlign];
                buffer = new byte[mixer.WaveFormat.AverageBytesPerSecond / 10];

                //Set Output
                waveFileWriter = new WaveFileWriter(saveFileDialog.FileName, mixer.WaveFormat);

                toolStripProgressBar.Maximum = (int)(mixer.Length / 10000);

                //Write Data
                while (mixer.Position < mixer.Length - 1)
                //for (int i = 0; i < waveFileReader.Length / waveFileReader.WaveFormat.BlockAlign; i++)
                {
                    toolStripProgressBar.Value = Math.Min((int)(mixer.Position / 10000), toolStripProgressBar.Maximum);
                    toolStripProgressBar.Invalidate();

                    //Music ran out
                    if (waveStream.Position >= waveStream.Length - 1)
                    {
                        //mixer.RemoveInputStream(waveStream);
                        //waveStream.Position = 0;
                        //mixer.AddInputStream(waveStream);
                    }

                    //Write Data
                    mixer.Read(buffer, 0, buffer.Length);

                    for (int j = 0; j < buffer.Length; j++)
                    {
                        waveFileWriter.Write(buffer, 0, buffer.Length);
                    }
                }

                //Close all Streams
                waveStream.Close();
                waveFileReader.Close();
                mixer.Close();
                waveFileWriter.Flush();
                waveFileWriter.Close();*/

                #endregion

                MessageBox.Show("Export erfolgreich.");
            }
        }



        private void setTimeLine()
        {
            //Variables
            List<string> events = new List<string>();
            List<int> secondsToDeploy = new List<int>();
            Bitmap bitmap = new Bitmap(pictureBox_timeSlider.Width, pictureBox_timeSlider.Height);
            Graphics graphics = Graphics.FromImage(bitmap);

            //Get all Events
            for (int i = 0; i < dataGridView_missionData.Rows.Count; i++)
            {
                events.Add(dataGridView_missionData[1, i].Value.ToString());
                secondsToDeploy.Add((int)TimeSpan.ParseExact(dataGridView_missionData[4, i].Value.ToString(), @"mm\:ss", CultureInfo.InvariantCulture).TotalSeconds);
            }

            //Draw Background
            graphics.FillRectangle(Brushes.LightGray, new Rectangle(0, 0, pictureBox_timeSlider.Width - 1, pictureBox_timeSlider.Height - 1));
            
            //Draw Events
            while (events.Count > 0)
            {
                //Essentials
                if (events[0].Equals("Mission gestartet") || events[0].Equals("Phase 1 endet in 60 Sekunden") || events[0].Equals("Phase 1 endet in 20 Sekunden") || events[0].Equals("Phase 1 beendet") ||
                    events[0].Equals("Phase 2 endet in 60 Sekunden") || events[0].Equals("Phase 2 endet in 20 Sekunden") || events[0].Equals("Phase 2 beendet") || events[0].Equals("Mission endet in 60 Sekunden") ||
                    events[0].Equals("Mission endet in 20 Sekunden") || events[0].Equals("Mission beendet"))
                {
                    graphics.DrawLine(new Pen(Color.Black, 3), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, 0), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, pictureBox_timeSlider.Height));
                }

                //Threats
                if (events[0].Equals("Bedrohung") || events[0].Equals("Ernsthafte Bedrohung"))
                {
                    graphics.DrawLine(new Pen(Color.Red, 3), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, 0), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, pictureBox_timeSlider.Height));
                }

                //Internal Threats
                if (events[0].Equals("Interne Bedrohung") || events[0].Equals("Ernsthafte Interne Bedrohung"))
                {
                    graphics.DrawLine(new Pen(Color.GreenYellow, 3), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, 0), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, pictureBox_timeSlider.Height));
                }

                //Incomming Data and Data Transfer
                if (events[0].Equals("Datenübertragung") || events[0].Equals("Eingehende Daten"))
                {
                    graphics.DrawLine(new Pen(Color.CornflowerBlue, 3), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, 0), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, pictureBox_timeSlider.Height));
                }

                //Communications Blackout
                if (events[0].Equals("Kommunikation gestört (kurz)") || events[0].Equals("Kommunikation gestört (lang)"))
                {
                    graphics.DrawLine(new Pen(Color.Yellow, 3), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, 0), new Point(secondsToDeploy[0] * pictureBox_timeSlider.Width / 600, pictureBox_timeSlider.Height));
                }

                //Event handled, remove
                events.RemoveAt(0);
                secondsToDeploy.RemoveAt(0);
            }

            //Draw Border
            graphics.DrawRectangle(Pens.Black, new Rectangle(0, 0, pictureBox_timeSlider.Width - 1, pictureBox_timeSlider.Height - 1));

            pictureBox_timeSlider.Image = bitmap;
        }

        

        /// <summary>
        /// Whos the amount of Threats in the corresponding Textbox.
        /// </summary>
        private void setThreatCount()
        {
            //Variables
            int threats = 0;

            //Count Threats
            for (int i = 0; i < dataGridView_missionData.Rows.Count; i++)
            {
                if (dataGridView_missionData[1, i].Value.ToString().Equals("Bedrohung") ||
                    dataGridView_missionData[1, i].Value.ToString().Equals("Interne Bedrohung"))
                {
                    threats++;
                }

                if (dataGridView_missionData[1, i].Value.ToString().Equals("Ernsthafte Bedrohung") ||
                    dataGridView_missionData[1, i].Value.ToString().Equals("Ernsthafte Interne Bedrohung"))
                {
                    threats += 2;
                }
            }

            //Output to Textbox
            if(threats == 0)
            {
                textBox_threats.Text = "Bedrohungen";
            }
            else
            {
                textBox_threats.Text = threats.ToString() + @" / 8";
            }

            if(threats <= 6)
            {
                textBox_threats.Text = "Sehr einfach";
            }

            if (threats == 7)
            {
                textBox_threats.Text = "Einfach";
            }

            if (threats == 8)
            {
                textBox_threats.Text = "Normal";
            }

            if (threats == 9)
            {
                textBox_threats.Text = "Schwer";
            }

            if (threats == 10)
            {
                textBox_threats.Text = "Unmöglich";
            }

        }

        

        

        
    }
}
